org.springframework.http.client

## Interface ClientHttpResponse

- All Superinterfaces:
    AutoCloseable, Closeable, HttpInputMessage, HttpMessage
  All Known Implementing Classes:
    AbstractClientHttpResponse, MockClientHttpResponse

      public interface ClientHttpResponse
      extends HttpInputMessage, Closeable

  Represents a client-side HTTP response.

  Obtained via an invocation of `ClientHttpRequest.execute()`.

  A `ClientHttpResponse` must be closed, typically in a `finally` block.

  Since:
    3.0
  Author:
    Arjen Poutsma

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close this response, freeing any resources created.
    `int` | `getRawStatusCode()` Get the HTTP status code (potentially non-standard and not resolvable through the `HttpStatus` enum) as an integer.
    `HttpStatus` | `getStatusCode()` Get the HTTP status code as an `HttpStatus` enum value.
    `String` | `getStatusText()` Get the HTTP status text of the response.

    - ### Methods inherited from interface org.springframework.http.HttpInputMessage

      `getBody`

    - ### Methods inherited from interface org.springframework.http.HttpMessage

      `getHeaders`

- - ### Method Detail

    - #### getStatusCode

          HttpStatus getStatusCode()
                            throws IOException

      Get the HTTP status code as an `HttpStatus` enum value.

      For status codes not supported by `HttpStatus`, use `getRawStatusCode()` instead.

      Returns:
        the HTTP status as an HttpStatus enum value (never `null`)
      Throws:
        `IOException` - in case of I/O errors
        `IllegalArgumentException` - in case of an unknown HTTP status code
      Since:
        #getRawStatusCode()
      See Also:
        `HttpStatus.valueOf(int)`

    - #### getRawStatusCode

          int getRawStatusCode()
                        throws IOException

      Get the HTTP status code (potentially non-standard and not resolvable through the `HttpStatus` enum) as an integer.
      Returns:
        the HTTP status as an integer value
      Throws:
        `IOException` - in case of I/O errors
      Since:
        3.1.1
      See Also:
        `getStatusCode()`, `HttpStatus.resolve(int)`

    - #### getStatusText

          String getStatusText()
                        throws IOException

      Get the HTTP status text of the response.
      Returns:
        the HTTP status text
      Throws:
        `IOException` - in case of I/O errors

    - #### close

          void close()

      Close this response, freeing any resources created.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Closeable`